| Flutter Impeller |

Public Member Functions | List of all members
impeller::RoundSuperellipseGeometry Class Referencefinal

`#include <round_superellipse_geometry.h>`

Inheritance diagram for impeller::RoundSuperellipseGeometry:

## Public Member Functions
| RoundSuperellipseGeometry (const Rect &bounds, const RoundingRadii &radii)
| RoundSuperellipseGeometry (const Rect &bounds, float corner_radius)
| ~RoundSuperellipseGeometry () override
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const
virtual Scalar | ComputeAlphaCoverage (const Matrix &transform) const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const Path &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const Path &path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

Geometry class that can generate vertices for a rounded superellipse.

A rounded superellipse is a shape similar to a typical rounded rectangle (`RoundRect`), but with smoother transitions between the straight sides and the rounded corners. It resembles the `RoundedRectangle` shape in SwiftUI with the `.continuous` corner style. Technically, it is created by replacing the four corners of a superellipse (also known as a Lamé curve) with circular arcs.

The `bounds` defines the position and size of the shape. The `corner_radius` corresponds to SwiftUI's `cornerRadius` parameter, which is close to, but not exactly equals to, the radius of the corner circles.

Definition at line 25 of file round_superellipse_geometry.h.

## Constructor & Destructor Documentation

## ◆ RoundSuperellipseGeometry() [1/2]

impeller::RoundSuperellipseGeometry::RoundSuperellipseGeometry | ( | const Rect & | bounds,
|  | const RoundingRadii & | radii
| ) |  |

Definition at line 366 of file round_superellipse_geometry.cc.

368 : bounds_(bounds.GetPositive()), radii_(radii.Scaled(bounds_)) {}

## ◆ RoundSuperellipseGeometry() [2/2]

impeller::RoundSuperellipseGeometry::RoundSuperellipseGeometry | ( | const Rect & | bounds,
|  | float | corner_radius
| ) |  |

Definition at line 370 of file round_superellipse_geometry.cc.

372 : RoundSuperellipseGeometry(bounds,
373 RoundingRadii::MakeRadius(corner_radius)) {}
impeller::RoundSuperellipseGeometry::RoundSuperellipseGeometry
RoundSuperellipseGeometry(const Rect &bounds, const RoundingRadii &radii)
Definition: round_superellipse_geometry.cc:366
impeller::RoundingRadii::MakeRadius
constexpr static RoundingRadii MakeRadius(Scalar radius)
Definition: rounding_radii.h:20

## ◆ ~RoundSuperellipseGeometry()

impeller::RoundSuperellipseGeometry::~RoundSuperellipseGeometry | ( |  | ) |
| override

Definition at line 375 of file round_superellipse_geometry.cc.

375 {}

## Member Function Documentation

## ◆ CoversArea()

bool impeller::RoundSuperellipseGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| override virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 442 of file round_superellipse_geometry.cc.

443 {
444 if (!transform.IsTranslationScaleOnly()) {
445 return false;
446 }
447 Scalar left_inset = std::max(radii_.top_left.width, radii_.bottom_left.width);
448 Scalar right_inset =
449 std::max(radii_.top_right.width, radii_.bottom_right.width);
450 Scalar top_inset = std::max(radii_.top_left.height, radii_.top_right.height);
451 Scalar bottom_inset =
452 std::max(radii_.bottom_left.height, radii_.bottom_right.height);
453 Rect coverage =
454 Rect::MakeLTRB(bounds_.GetLeft() + left_inset * kGapFactor,
455 bounds_.GetTop() + top_inset * kGapFactor,
456 bounds_.GetRight() - right_inset * kGapFactor,
457 bounds_.GetBottom() - bottom_inset * kGapFactor);
458 return coverage.TransformBounds(transform).Contains(rect);
459 }
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:214
impeller::Scalar
float Scalar
Definition: scalar.h:18
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:792
impeller::RoundingRadii::top_right
Size top_right
Definition: rounding_radii.h:16
impeller::RoundingRadii::bottom_left
Size bottom_left
Definition: rounding_radii.h:17
impeller::RoundingRadii::bottom_right
Size bottom_right
Definition: rounding_radii.h:18
impeller::RoundingRadii::top_left
Size top_left
Definition: rounding_radii.h:15
impeller::TRect::GetBottom
constexpr auto GetBottom() const
Definition: rect.h:361
impeller::TRect::GetTop
constexpr auto GetTop() const
Definition: rect.h:357
impeller::TRect::GetLeft
constexpr auto GetLeft() const
Definition: rect.h:355
impeller::TRect::GetRight
constexpr auto GetRight() const
Definition: rect.h:359
impeller::TRect< Scalar >::MakeLTRB
constexpr static TRect MakeLTRB(Type left, Type top, Type right, Type bottom)
Definition: rect.h:129
impeller::TSize::height
Type height
Definition: size.h:29
impeller::TSize::width
Type width
Definition: size.h:28

References impeller::RoundingRadii::bottom_left, impeller::RoundingRadii::bottom_right, impeller::TRect< T >::Contains(), impeller::TRect< T >::GetBottom(), impeller::TRect< T >::GetLeft(), impeller::TRect< T >::GetRight(), impeller::TRect< T >::GetTop(), impeller::TSize< T >::height, impeller::TRect< Scalar >::MakeLTRB(), impeller::RoundingRadii::top_left, impeller::RoundingRadii::top_right, transform, impeller::TRect< T >::TransformBounds(), and impeller::TSize< T >::width.

## ◆ IsAxisAlignedRect()

bool impeller::RoundSuperellipseGeometry::IsAxisAlignedRect | ( |  | ) | const
| override virtual

Reimplemented from impeller::Geometry.

Definition at line 461 of file round_superellipse_geometry.cc.

461 {
462 return false;
463 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/round_superellipse_geometry.h
- impeller/entity/geometry/round_superellipse_geometry.cc